// Programa GravimetricBaixada per mesurar els temsps de tall i l'acceleració a1 de baixada
// License: GNU GPL v3 http://www.gnu.org/copyleft/gpl.html 
int pinFTIR1 = 0; // selecciona el pin d'entrada per al sensor de llum SUPERIOR
int valFTIR1 = 0; // variable per emmagatzemar el valor capturat des del FTIR
int pinFTIR2 = 1; // selecciona el pin d'entrada per al sensor de llum MIG
int valFTIR2 = 0; // variable per emmagatzemar el valor capturat des del FTIR
int pinFTIR3 = 2; // selecciona el pin d'entrada per al sensor de llum INFERIOR
int valFTIR3 = 0; // variable per emmagatzemar el valor capturat des del FTIR
unsigned long tempsinicial; // Variable per emmagatzemar el temps inicial en microsegons
unsigned long tempsmig; // Variable per emmagatzemar el temps mig en microsegons
unsigned long tempsfinal; // Variable per emmagatzemar el temps final en microsegons
unsigned long  TempsInicial[9];//Variable per recollir els temps dels talls del feix de llum al cicle n
unsigned long  TempsMig[9];//Variable per recollir els temps dels talls del feix de llum al cicle n
unsigned long  TempsFinal[9];//Variable per recollir els temps dels talls del feix de llum al cicle n
unsigned long ti=0;//rep el valor del array TempsInicial[0]
unsigned long tm=0;//rep el valor del array TempsMig[0]
unsigned long tf=0;//rep el valor del array TempsFinal[0]
float TI ;//rebra valor decimal del ti
float TM ;//rebra valor decimal del tm
float TF ;//rebra valor decimal del tf
                        
float tB = 0;//temps que tarda en recorrer desde xA fins a xB
float tC = 0;//temps que tarda en recorrer desde xB fins a xC
float a1 = 0;//acceleracio de baixada pel tub
float DB = 0.63;//distancia de A a B
float DC = 1.23;//distancia de A a C
                        
int contador1=0;// Contador de feixos tallats sensor a0
int contador2=0;// Contador de feixos tallats sensor a1
int contador3=0;// Contador de feixos tallats sensor a2
                      
void setup() {
Serial.begin(9600); // Inicialitza el monitor serie per enviar-hi dades
pinMode(pinFTIR1, INPUT); // declara el FotoTransistor IR com entrada
pinMode(pinFTIR2, INPUT); // declara el FotoTransistor IR com entrada
pinMode(pinFTIR3, INPUT); // declara el FotoTransistor IR com entrada
	     }
void loop() { // Aquest és el començament d'un cicle infinit
tempsinicial = micros();//activem temps
tempsmig = micros();//activem temps
tempsfinal = micros();//activem temps

//SENSOR A0 SUPERIOR
valFTIR1 = analogRead(pinFTIR1); // llegeix i asigna a "valFTIR" un valor entre 0 i 1023
if(valFTIR1<1){  //Si el valor llegit es menor que 1 s'executen es instrucions de baix
Serial.print("Feix de llum TALLAT EN SENSOR 1 AMB VALOR="); //Imprimeix el retol
Serial.println(valFTIR1); //Imprimeix la dada val i retorna final de línia
Serial.print("Temps inicial="); //Imprimeix el retol
Serial.println(tempsinicial); //Imprimeix la dada val i retorna final de línia
//Comptador temps inicial
tempsinicial = micros();
TempsInicial[contador1]=tempsinicial;
contador1=contador1+1;
		}
			
//SENSOR A1 MIG
valFTIR2 = analogRead(pinFTIR2); // llegeix i asigna a "valFTIR" un valor entre 0 i 1023
if(valFTIR2<1){  //Si el valor llegit es menor que 1 s'executen es instrucions de baix
Serial.print("Feix TALLAT EN SENSOR 2 valor="); //Imprimeix el retol
Serial.println(valFTIR2); //Imprimeix la dada val i retorna final de línia
Serial.print("Temps mig="); //Imprimeix el retol
Serial.println(tempsmig); //Imprimeix la dada val i retorna final de línia
//Comptador temps mig
tempsmig = micros();
TempsMig[contador2]=tempsmig;
contador2=contador2+1;
		}
                  
//SENSOR A2 FINAL
valFTIR3 = analogRead(pinFTIR3); // llegeix i asigna a "valFTIR" un valor entre 0 i 1023
if(valFTIR3<1){  //Si el valor llegit es menor que 1 s'executen es instrucions de baix
Serial.print("Feix TALLAT SENSOR 3 valor="); //Imprimeix el retol
Serial.println(valFTIR3); //Imprimeix la dada val i retorna final de línia
Serial.print("Temps final="); //Imprimeix el retol
Serial.println(tempsfinal); //Imprimeix la dada val i retorna final de línia
//Comptador temps final
tempsfinal = micros();
TempsFinal[contador3]=tempsfinal;
contador3=contador3+1;
		}
		        
if(contador3==1){
ti=TempsInicial[0];
tm=TempsMig[0];
tf=TempsFinal[0];
                        
Serial.print("Temps inicial="); //Imprimeix el retol
Serial.println(ti); //Imprimeix la dada val i retorna final de línia
Serial.print("Temps mig="); //Imprimeix el retol
Serial.println(tm); //Imprimeix la dada val i retorna final de línia
Serial.print("Temps final="); //Imprimeix el retol
Serial.println(tf); //Imprimeix la dada val i retorna final de línia
                        
// Calculs de acceleracio
TI = (float)ti;
TM = (float)tm;
TF = (float)tf;
tB= (TM-TI)/1000000;//temps desde A fins B
tC= (TF-TI)/1000000;//temps desde A fins C
a1= 2*(((DC*tB)-(DB*tC))/(tB*tC*(tC-tB)));
Serial.print("tB = "); //Imprimeix el retol
Serial.print(tB);
Serial.println(" s");
Serial.print("tC = "); //Imprimeix el retol
Serial.print(tC);
Serial.println(" s");
Serial.print("a1 = "); //Imprimeix el retol
Serial.print(a1);
Serial.println(" m/s2");
delay(60000);
                    
                }
			
} //Aquest és el final del cicle

